﻿// Even-Odd Demo
// MainForm.cs
// Shows form that interacts with custom dialog box

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace EvenOdd
{
    public partial class MainForm : Form
    {
        // Precondition:  None
        // Postcondition: The MainForm GUI is initialized
        public MainForm()
        {
            InitializeComponent();
        }

        // Precondition:  The tryBtn has been clicked
        // Postcondition: A dialog box has been displayed prompting for
        //                a number. If user submits, MainForm is updated
        //                to display value and whether even or odd.
        private void tryBtn_Click(object sender, EventArgs e)
        {
            InputBox inputBox = new InputBox(); // The dialog box form
            DialogResult result;                // Result from dialog - OK/Cancel?
            string message;                     // Even/odd message
            int num;                            // User's input (gather from dialog box)

            result = inputBox.ShowDialog(); // Show dialog box form - modal, waits for OK/Cancel
                                            // Even after user dismisses, the form still exists
                                            // and can be interacted with using methods/properties

            if (result == DialogResult.OK)  // Only update if user chose OK from dialog box
            {
                num = int.Parse(inputBox.InputValue); // Retrieve value from dialog box
                message = "That is: " +
                  ((num % 2 == 0) ? "even" : "odd");  // By defn. even numbers are divisible by 2
                enteredLbl.Text = "You Entered: " + num;
                evenOddLbl.Text = message;
            }
        }

        private void MainForm_Load(object sender, EventArgs e)
        {

        }
    }
}