﻿// Program 4
// CIS 200-01
// Fall 2018
// Due: 11/26/2018
// By: D1713

// File: TestParcels.cs
// This is a simple, console application designed to exercise the Parcel hierarchy.
// It creates several different Parcels and prints them.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Prog4
{
    class TestParcels
    {
        // Precondition:  None
        // Postcondition: Parcels have been created and displayed
        static void Main(string[] args)
        {
            // Test Data - Magic Numbers OK
            Address a1 = new Address("  John Smith  ", "   123 Any St.   ", "  Apt. 45 ",
                "  Louisville   ", "  KY   ", 40202); // Test Address 1
            Address a2 = new Address("Jane Doe", "987 Main St.",
                "Beverly Hills", "CA", 90210); // Test Address 2
            Address a3 = new Address("James Kirk", "654 Roddenberry Way", "Suite 321",
                "El Paso", "TX", 79901); // Test Address 3
            Address a4 = new Address("John Crichton", "678 Pau Place", "Apt. 7",
                "Portland", "ME", 04101); // Test Address 4
            Address a5 = new Address("Bob Lee", "546 Lincoln Ave.", "Apt. 5",
                "Boston", "MA", 06532); // Test Address 5
            Address a6 = new Address("Ryan Smith", "1345 Lexington Road", "Room 12",
                "Phoenix", "AZ", 87654); // Test Address 6
            Address a7 = new Address("Sarah Carter", "8130 Timothy Lane", "Suite 2",
                "Toledo", "OH", 45632); // Test Address 7
            Address a8 = new Address("Steve Johnson", "432 3rd Street", "Apt. 1",
                "Louisville", "KY", 50242); // Test Address 8

            Letter letter1 = new Letter(a1, a2, 3.95M);                            // Letter test objects
            Letter letter2 = new Letter(a2, a7, 4.52M);
            Letter letter3 = new Letter(a4, a3, 3.45M);
            GroundPackage gp1 = new GroundPackage(a3, a4, 14, 10, 5, 12.5);        // Ground test objects
            GroundPackage gp2 = new GroundPackage(a7, a8, 12, 14.5, 24.2, 10.5);
            GroundPackage gp3 = new GroundPackage(a1, a2, 10, 12.3, 18.2, 8.99);
            NextDayAirPackage ndap1 = new NextDayAirPackage(a1, a3, 25, 15, 15,    // Next Day test objects
                85, 7.50M);
            NextDayAirPackage ndap2 = new NextDayAirPackage(a3, a6, 21, 16, 25, 
                42, 10.50M);
            TwoDayAirPackage tdap1 = new TwoDayAirPackage(a4, a1, 46.5, 39.5, 28.0, // Two Day test objects
                80.5, TwoDayAirPackage.Delivery.Saver);
            TwoDayAirPackage tdap2 = new TwoDayAirPackage(a4, a5, 32.4, 31, 40.1,
                60.40, TwoDayAirPackage.Delivery.Early);

            List<Parcel> parcels;      // List of test parcels
            parcels = new List<Parcel>();

            parcels.Add(letter1); // Populate list
            parcels.Add(letter2);
            parcels.Add(letter3);
            parcels.Add(gp1);
            parcels.Add(gp2);
            parcels.Add(gp3);
            parcels.Add(ndap1);
            parcels.Add(ndap2);
            parcels.Add(tdap1);
            parcels.Add(tdap2);
            
            // Original list of parcels
            Console.WriteLine("Original List:");
            Console.WriteLine("====================");
            foreach (Parcel p in parcels)
            {
                Console.WriteLine(p);
                Console.WriteLine("====================");
            }
            Pause();

            // Sort parcels by cost
            Console.WriteLine("Order By Cost List:");
            Console.WriteLine("====================");
            parcels.Sort();
            foreach (Parcel p in parcels)
            {
                Console.WriteLine(p);
                Console.WriteLine("====================");
            }
            Pause();

            // Sort parcels by destination zip (descending)
            Console.WriteLine("Descending Order By DestZip List:");
            Console.WriteLine("==============================");
            parcels.Sort(new DescendingOrderZip());
            foreach (Parcel p in parcels)
            {
                Console.WriteLine(p);
                Console.WriteLine("====================");
            }
            Pause();

            // Ex-Credit sort parcels by Parcel type then cost (descending)
            Console.WriteLine("Order By Parcel Type then Cost Descending List:");
            Console.WriteLine("================================================");
            parcels.Sort(new ParcelTypeOrder());
            foreach (Parcel p in parcels)
            {
                Console.WriteLine(p);
                Console.WriteLine("====================");
            }
            Pause();

        }

        // Precondition:  None
        // Postcondition: Pauses program execution until user presses Enter and
        //                then clears the screen
        public static void Pause()
        {
            Console.WriteLine("Press Enter to Continue...");
            Console.ReadLine();

            Console.Clear(); // Clear screen
        }
    }
}
