﻿/* 
 W9847
 Program 4
 4/24/18
 CIS-199-01

 This program calculates the cost to deliver a package from one zip code to another
 using the length, width, height, and weight of the package.
 */
using System;
using static System.Console;

namespace Program_4
{
    class GroundPackage
    {
        private int originZip;
        private int destinatonZip;
        private double length;
        private double width;
        private double height;
        private double weight;

        public GroundPackage(int origin, int destination, double length, double width, double height, double weight)
        {
            OriginZip = origin; //Origin Zip Code
            DestinatonZip = destination; // Destination Zip Code
            Length = length; // package length
            Width = width; // Package width
            Height = height; // Package height
            Weight = weight; // Pack weight

        }

        public int OriginZip  // Property
        {
            //Precondition: None
            //Postcondition: Return origin zip code
            get
            {
                return originZip;
            }

            //Precondition: origin zip code must be between 10000 and 99999
            //Postcondition: Origin zip code is set to a value.
            set
            {
                if (value >= 10000 && value <= 99999)
                    originZip = value;
                else
                    originZip = 40202; // default origin zip set to 40242
            }
        }

        public int DestinatonZip
        {
            //Precondition: none
            //Postcondition: return destination zip code
            get
            {
                return destinatonZip;
            }
            //Precondition: destination zip code must be between 10000 and 99999
            //Postcondition: destination zip code is set to a value
            set
            {
                if (value >= 10000 && value <= 99999)
                    destinatonZip = value;
                else
                    destinatonZip = 90210; // default destination zip set to 90210
            }
        }

        public double Length
        {
            //Precondition: none
            //Postcondition: return length
            get
            {
                return length;
            }
            //Precondition: length must be greater than 0
            //Postcondition: value is set for the length 
            set
            {
                // If value is not valid, set it to 1
                if (value > 0)
                    length = value;
                else
                    length = 1.0; // default length set to 1.0
            }
        }

        public double Width
        {
            //Precondition: none
            //Postcondition: return width
            get
            {
                return width;
            }
            //Precondition: value must be greater than 0
            //Postcondition: value for width is set
            set
            {
                // If value is not valid, set it to 1
                if (value > 0)
                    width = value;
                else
                    width = 1.0; //default width set to 1.0
            }
        }

        public double Height
        {
            //Precondition: none
            //Postcondition: height is returned
            get
            {
                return height;
            }
            //Precondition: the value for height must be greater than 0
            //Postcondition: value is set for the height
            set
            {
                if (value > 0)
                    height = value;
                else
                    height = 1.0; // default value of 1.0            
            }
        }

        public double Weight
        {
            //Precondition: none
            //Postcondition: weight is returned
            get
            {
                return weight;
            }
            //Precondition: the value for weight must be greater than 0
            //Postcondition: value is set for the weight
            set
            {
                if (value > 0)
                    weight = value;
                else
                    weight = 1.0; // default weight set to 1 pound
            }
        }

        public int ZoneDistance
        {
            //precondition: none
            //postcondition: return zone distance
            get
            {
                int zoneDist = OriginZip/10000;// first digit origin zip code
                int destination = DestinatonZip/10000; // first digit destination zip code
                return zoneDist-destination; // zone distance
            }
        }
        public override string ToString()
        {
            // Display origin zip
            //destination zip
            //length
           // width
           // height
           // and length
            return $"Origin Zip Code: {OriginZip}" + Environment.NewLine + // return each on separate line
            $"Destination Zip Code: {DestinatonZip}" + Environment.NewLine +
            $"Length (inches) = {Length}" + Environment.NewLine +
            $"Width (inches) = {Width}" + Environment.NewLine +
            $"Height (inches) = {Height}" + Environment.NewLine +
            $"Weight = {Weight} lbs.";
        }
        //Precondition: none
        //Postcondition: returns the cost of the package delivery
        public double CalcCost()
        {
            double cost = .20*(Length + Width + Height)+.5 *(ZoneDistance+1)*(Weight); // Calculate cost
            return cost; // return cost
        }
    }
    class Test
    {
        static void Main(string[] args)
        {
            // hard coded test packages
            GroundPackage pack1 = new GroundPackage(10000, 20000, 10.4, 20, 10, 50); 
            GroundPackage pack2 = new GroundPackage(40000, 45333, 50, 50, 40, 15);
            GroundPackage pack3 = new GroundPackage(12345, 33333, 20.9, 50.2, 40, 25);
            GroundPackage pack4 = new GroundPackage(60000, 25355, 70.5, 50.65, 30, 5);
            GroundPackage pack5 = new GroundPackage(54321, 11111, 100, 85, 55, 2);
            
            GroundPackage[] packages = {pack1, pack2, pack3, pack4, pack5}; // packages array
            
            DisplayPackages(packages); // display packages using DisplayPackages method
        }

        static void DisplayPackages(GroundPackage[] packages)
        {
            for (int i = 0; i < packages.Length; i++)// for loop for groundpackage array
            {
                WriteLine("Package: "+ (i+1)); // package #
                WriteLine(packages[i]); // loop through packages
                WriteLine($"{"Shipping Cost"}: ${packages[i].CalcCost()}\n"); // Calculate shipping cost using CalcCost method
            }
        }
    }
}


